;
; tHg]
; gRAMpbÑ`FbN
; SD6031̃`FbN
;

	relaxed on

SENDCMD		equ	$019b
SENDDT		equ	$019e
RCVDT		equ	$01a1
DRVSTATUS	equ	$ed5a
RBANK		equ	$d803
WBANK		equ	$d806
RBANKROM	equ	$d809
WBANKROM	equ	$d80c
HOOKTERM	equ	$e791
ANA_EXP		equ	$37d9
GET_WORD	equ	$3e1b
GET_BYTE	equ	$4bf7
GET_STICK	equ	$0552
WPORT68		equ	$e6af
DISKRW		equ	$0198

DISKBUF		equ	$af00
DISKNUM		equ	$dffc
EXFDDF		equ	$dffe
EXRAMF		equ	$dfff

	org	$d700

	jp	TENSO		; D700
	jp	EXRAMC		; D703
	jp	EXFDDC		; D706
	jp	CHKDISKNUM	; D709


	org	$d710

DISTSTART:
	dw	$0000		; D710
SRCSTART:
	dw	$0000		; D712
DATASIZE:
	dw	$0000		; D714


;
; tHg]
;
TENSO:

	di
	ld	hl,WPORT68
	ld	de,WPORTBUF
	ld	bc,$0004
	ldir

	ld	a,$20
	call	WBANK

	ld	hl,WPORT68
	ld	(hl),$20
	inc	hl
	ld	(hl),$22
	inc	hl
	ld	(hl),$24
	inc	hl
	ld	(hl),$26
	inc	hl

	ei

	ld	de,(DISTSTART)
	ld	bc,(DATASIZE)
	ld	hl,(SRCSTART)
	ldir

	di
	ld	hl,WPORTBUF
	ld	de,WPORT68
	ld	bc,$0004
	ldir

	call	WBANKROM
	ei

	ret

WPORTBUF:
	db	$00,$00,$00,$00


;
; gRAMpbÑ`FbN
;
; (EXRAMF):
; 0x00:16K
; 0x01:64K
; 0xFF:Ȃ
;
EXRAMC:
	call	GET_STICK
	and	$01
	ld	b,$00
	jr	nz,.end

	di

	ld	a,$20
	call	RBANK

	ld	a,$20
	call	WBANK

	ld	a,$55
	ld	($3fff),a
	ld	a,$aa
	ld	($7fff),a

	ld	a,($3fff)
	cp	$55		; 64K
	ld	b,$01
	jr	z,.end
	ld	b,$00
	cp	$aa		; 16K
	jr	z,.end
	ld	b,$ff

.end:
	ld	a,b
	ld	(EXRAMF),a

	call	RBANKROM
	call	WBANKROM

	ei
	ret


;
; SD6031̃`FbN
;
; (EXFDDF):
; 0x00:SD6031Ȃ
; 0x01:SD6031
;
EXFDDC:
	xor	a
	ld	(EXFDDF),a

	ld	a,(DRVSTATUS)
	cp	$c0			; OtQhCuAȂ
	ret	nz


		;
		; Get Memory $07EF,$07F0
		;
	ld	a,$0b
	call	SENDCMD	
	ret	c
	ld	a,$07
	call	SENDDT
	ret	c
	ld	a,$ef
	call	SENDDT
	ret	c
	ld	a,$00
	call	SENDDT
	ret	c
	ld	a,$02
	call	SENDDT
	ret	c

	call	RCVDT
	ret	c
	ld	b,a
	call	RCVDT
	ret	c
	ld	c,a

	ld	a,b
	cp	$40		; P6VW
	ret	z
	cp	$ff		; SD6031/PC-80S31ȊO
	ret	z

	ld	a,c
	cp	$ff
	ret	nz

	ld	a,$01
	ld	(EXFDDF),a
	ret

;
; fBXNԍǂݏo
;
; gbNԍF37i0x25j
; ZN^ԍ@F12i0x0Cj
;
CHKDISKNUM:

	ld	b,37
	ld	c,12
	ld	de,DISKBUF
	ld	a,1
	or	a
	call	DISKRW

	ld	a,(DISKBUF+255)
	ld	(DISKNUM),a

	ret


	org	$d7ff

	db	$00


end
