;
; BGM炷
;
; ݒFEXEC BGM_SET
; BGM~FEXEC BGM_STOP
; BGMĐFEXEC BGM_START
;
;

	relaxed on

DATADD:		equ	$8900
FMTIMBLE:	equ	$b200
P_FLAG:		equ	$df0c
READBUF:	equ	$24ba
SETBACKBUF:	equ	$24f8


	org	$a900

	jp	BGM_SETMAIN	; $A900
	jp	BGM_INTMAIN	; $A903
	jp	POKKY_INIT	; $A906


;
; 荞݊Ԋu2/1024b
; T=120̏ꍇAL4 * 120 = P = 512 * 60 񊄂荞
;
; L64*9(ŏPj*16 * T = 512 * 60 񊄂荞
;
; 荞݂P񓖂
; T * 144 / (512*60) = T * 3 / 640  T / 213.3
;
; ̍ŏKv
;
; T=213.3 (= 640/3) ̎A640640ij
; T=120 ̎A640360iT*3j
;
; T=214傫͖̂ΉBRA͖ΉB
;

BGM_SETMAIN:
	push	ix
	xor	a
	ld	(P_FLAG),a

;	ld	a,' '		; debug
;	ld	($0000),a	; debug

		;
		; ̏ݒ
		;

	ld	a,$28
	ld	e,$00
	call	OUTOPN		; CH0fBZ[u
	ld	a,$28
	ld	e,$01
	call	OUTOPN		; CH1fBZ[u
	ld	a,$28
	ld	e,$02
	call	OUTOPN		; CH2fBZ[u

	ld	e,$bf
	ld	a,$07
	call	OUTOPN		; CH3,4,5fBZ[u

	ld	hl,TEMPONUM
	ld	de,120*3
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl		; TEMPOREST
	ld	de,640
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl		; RCNT
	xor	a
	ld	(hl),a
	inc	hl		; MBACKFLAG
	ld	(hl),a
	inc	hl		; TEMPOFLAG
	ld	(hl),a

	call	INIT_MML

		;
		; [NGȀݒ
		;
	ld	b,6
	ld	de,CH0DAT
.linit:	push	bc
	ld	hl,DATDEF
	ld	bc,CHDATNUM
	ldir
	pop	bc
	djnz	.linit

		;
		; FM̉FAʂ̏ݒ
		;
	xor	a
	ld	ix,CH0DAT
	ld	(ANACH),a
	ld	e,$00
	call	ANA_MML.timble_set
	ld	a,$01
	ld	ix,CH1DAT
	ld	(ANACH),a
	ld	e,$00
	call	ANA_MML.timble_set
	ld	a,$02
	ld	ix,CH2DAT
	ld	(ANACH),a
	ld	e,$00
	call	ANA_MML.timble_set

	ld	a,$03
	ld	ix,CH3DAT
	ld	e,$0a
	call	ANA_MML.ssg_volume

	ld	a,$04
	ld	ix,CH4DAT
	ld	e,$0a
	call	ANA_MML.ssg_volume

	ld	a,$05
	ld	ix,CH5DAT
	ld	e,$0a
	call	ANA_MML.ssg_volume

	xor	a
	ld	(ANACH),a
	ld	ix,CH0DAT

.lp_set:
	call	READ_MML
	jr	z,.no_data
	jr	c,.lp_set
	call	ANA_MML
	jr	.lp_set

.no_data:
	jr	nc,.set_end
	xor	a
	ld	(ix+CHENB),a		; ̃`l̓fBZ[u
	ld	a,$01
	ld	(ix+MMLENDFLAG),a

.set_end:
	ld	a,(ANACH)
	inc	a
	ld	(ANACH),a
	ld	de,CHDATNUM
	add	ix,de
	cp	$06
	jr	c,.lp_set

	pop	ix
	ret


;
; MML̉͂Ə
;
; IX <= ̃`l̃[NAhXiCH0DAT`CH5DAT)
; (STRBUF):MML؂o
; (ANACH):Ă`lԍi0`2FFMA3`5FSSGj
;
ANA_MML:
	ld	hl,STRBUF
	ld	a,(hl)
	inc	hl

	cp	'c'
	jr	z,.tone_c+1
	cp	'd'
	jr	z,.tone_d+1
	cp	'e'
	jr	z,.tone_e+1
	cp	'f'
	jr	z,.tone_f+1
	cp	'g'
	jr	z,.tone_g+1
	cp	'a'
	jr	z,.tone_a+1
	cp	'b'
	jr	z,.tone_b+1
	jp	.com1

.tone_c:ld	bc,$001e	; ld	e,$00
.tone_d:ld	bc,$021e	; ld	e,$02
.tone_e:ld	bc,$041e	; ld	e,$04
.tone_f:ld	bc,$051e	; ld	e,$05
.tone_g:ld	bc,$071e	; ld	e,$07
.tone_a:ld	bc,$091e	; ld	e,$09
.tone_b:ld	bc,$0b1e	; ld	e,$0b

		;
		; K𔭉
		;
		; (b+,c- ͏Ȃj
		;
	ld	a,(hl)
	cp	'+'
	jr	z,.sharp
	cp	'#'
	jr	z,.sharp
	cp	'-'
	jr	nz,.natural

.flat:	dec	e
	dec	e
.sharp:	inc	e
	inc	hl

.natural:
	push	hl

	sla	e
	ld	d,$00

	ld	a,(ANACH)
	cp	$03
	jr	nc,.ssg_tone

		;
		; FM̉Kݒ肷
		;
	ld	hl,FMTONE
	add	hl,de

	ld	a,(ix+OCTAVE)
	dec	a
	and	$07
	rlca
	rlca
	rlca

	inc	hl
	ld	e,(hl)
	or	e
	ld	e,a
	ld	a,(ANACH)
	add	a,$a4
	call	OUTOPN

	dec	hl
	ld	e,(hl)
	ld	a,(ANACH)
	add	a,$a0
	call	OUTOPN

	jr	.tone_end

		;
		; SSG̉Kݒ肷
		;
.ssg_tone:
	ld	hl,SSGTONE
	add	hl,de

	ld	a,(ix+OCTAVE)
	ld	b,a

	ld	a,(hl)
	inc	hl
	ld	d,(hl)

.ssg_loop:
	srl	d
	rra
	djnz	.ssg_loop

	ld	e,a
	ld	a,(ANACH)
	sub	$03
	add	a,a		; 0,2,4
	call	OUTOPN

	ld	e,d
	ld	a,(ANACH)
	sub	$03
	add	a,a
	inc	a		; 1,3,5
	call	OUTOPN

.tone_end:
	pop	hl
	ld	a,(hl)
	cp	'&'
	ld	a,$00
	jr	nz,.no_tie
	ld	a,$01
	inc	hl
.no_tie:
	ld	(ix+TIEFLAG),a
	call	ANA_NUM
	call	LENGTHCONV
	ld	(ix+DATCNT),e
	xor	a
	ld	(ix+ANAENB),a

		;
		; ĂȂꍇA
		;
	ld	a,(ix+OUTENB)
	or	a
	ld	a,$01
	ld	(ix+OUTENB),a
	ret	nz

	ld	a,(ANACH)
	cp	$03
	jr	nc,.ssg_out

		;
		; FM𔭉
		;
	ld	a,(ANACH)
	or	$f0
	ld	e,a
	ld	a,$28		; L[I
	call	OUTOPN
	ret

.ssg_out:
	ld	a,$01
	ld	(SSGOUTFLAG),a

	ld	a,(ix+ENVENB)
	or	a
	ret	z

	ld	a,$0d
	call	INOPN
	ld	e,a
	ld	a,$0d
	call	OUTOPN

	ret


.com1:
	cp	'r'
	jr	z,.rest
	cp	'l'
	jr	z,.length
	cp	'>'
	jr	z,.octup
	cp	'<'
	jr	z,.octdown
	cp	'o'
	jr	z,.octave

	cp	'v'
	jr	z,.volume
	cp	'q'
	jr	z,.ratio

	cp	'@'
	jp	z,.atm
	cp	's'
	jp	z,.env_shape
	cp	'm'
	jp	z,.env_f
	cp	't'
	jp	z,.tempo

	ret

.rest:
	call	ANA_NUM
	call	LENGTHCONV
	ld	(ix+DATCNT),e

	xor	a
	ld	(ix+ANAENB),a

	ld	a,(ix+OUTENB)
	or	a
	ld	a,$00
	ld	(ix+OUTENB),a
	ret	z

		;
		; ĂꍇA~߂
		;
	ld	a,(ANACH)
	cp	$03
	jr	nc,.ssg_rest

		;
		; FM~߂
		;
	ld	a,(ANACH)
	ld	e,a
	ld	a,$28		; L[It
	call	OUTOPN
	ret

.ssg_rest:
		;
		; SSG~߂itÔ݁j
		;
	ld	a,$01
	ld	(SSGOUTFLAG),a
	ret

.octup:
	inc	(ix+OCTAVE)
	ret

.octdown:
	dec	(ix+OCTAVE)
	ret

.octave:
	call	ANA_NUM
	ld	(ix+OCTAVE),e
	ret

.ratio:
	call	ANA_NUM
	ld	(ix+RATIO),e
	ret

.length:
	call	ANA_NUM
	ld	a,e
	cp	24
	jr	z,.length_lp
	call	LENGTHCONV
.length_lp:
	ld	(ix+LENGTH),e
	ret

.volume:
	call	ANA_NUM
	ld	a,(ANACH)
	cp	$03
	jr	c,.v_fm

.ssg_volume:
	ld	(ix+CHVOL),e
	add	a,$05		; 3+5`5+5
	ld	d,a
	ld	a,(SSGOFFSET)
	add	a,e
				; $F1`$FF/$10`$1E
	cp	$10
	jr	c,.ssg_l1
	cp	$80
	ld	a,$0f
	jr	c,.ssg_l1
	xor	a
.ssg_l1:
	ld	e,a
	ld	a,d
	call	OUTOPN
	xor	a
	ld	(ix+ENVENB),a
	ret

.v_fm:
	ld	hl,.v_table
	ld	d,$00
	add	hl,de
	ld	a,(hl)
	jp	.fm_volume

.v_table:
	db	$55,$57,$5a,$5d,$5f,$62,$65,$67
	db	$6a,$6d,$6f,$72,$75,$77,$7a,$7d

.atm:
	ld	a,(hl)
	cp	'v'
	jr	nz,.timble
	inc	hl
	call	ANA_NUM
	ld	a,e

.fm_volume:
	ld	(ix+CHVOL),a
	cpl
	and	$7f
	ld	e,a
	ld	a,(FMOFFSET)
	add	a,e
				; $80`$FF/$80`$FE
	bit	7,a
	jr	z,.fm_l1
	ld	a,$7f
	bit	7,e
	jr	z,.fm_l1
	xor	a
.fm_l1:
	ld	e,a

	ld	a,(ANACH)
	add	a,$4c
	call	OUTOPN		; Iy[^#4

	ld	d,(ix+TIMALGO)
	ld	a,d
	cp	$04
	ret	c

	ld	a,(ANACH)
	add	a,$48
	call	OUTOPN		; Iy[^#2

	ld	a,d
	cp	$05
	ret	c

	ld	a,(ANACH)
	add	a,$44
	call	OUTOPN		; Iy[^#3

	ld	a,d
	cp	$07
	ret	c

	ld	a,(ANACH)
	add	a,$40
	call	OUTOPN		; Iy[^#1
	ret


.timble:
	call	ANA_NUM
	ld	a,(ix+TIMBLE)
	cp	e
	ret	z

.timble_set:
	ld	(ix+TIMBLE),e

	ld	d,$00
	ld	h,d
	ld	l,e
	add	hl,hl		; x2
	add	hl,de		; x3
	add	hl,hl		; x6
	add	hl,hl		; x12
	add	hl,hl		; x24
	add	hl,de		; x25
	ld	de,FMTIMBLE
	add	hl,de

	ld	a,(ANACH)
	add	a,$b0
	ld	e,(hl)
	call	OUTOPN		; Feedback/Algorithm

	ld	a,e
	and	$07
	ld	(ix+TIMALGO),a

	inc	hl
	ld	a,(ANACH)
	add	a,$30
	ld	b,24
.fmtim_lp:
	ld	e,(hl)
	push	af
	call	OUTOPN
	pop	af

	inc	hl
	add	a,$04
	djnz	.fmtim_lp

	ld	a,$6a
	jp	.fm_volume


.env_shape:
	call	ANA_NUM
	ld	a,$0d
	call	OUTOPN
	ld	e,$10
	ld	a,(ANACH)
	add	a,$05		; 3+5`5+5
	call	OUTOPN
	ld	a,$01
	ld	(ix+ENVENB),a
	ret

.env_f:
	ld	a,(hl)
	cp	'b'
	jr	z,.mback
	cp	'f'
	jr	z,.mforward

	call	ANA_NUM
	ld	a,$0b
	call	OUTOPN
	ld	e,d
	ld	a,$0c
	call	OUTOPN
	ret

.mback:
	ld	a,$01
	ld	(MBACKFLAG),a
	ret

.mforward:
	xor	a
	ld	(MBACKFLAG),a
	ret

.tempo:
	ld	a,(TEMPOFLAG)
	or	a
	ret	nz

	call	ANA_NUM
	ld	d,$00
	ld	h,d
	ld	l,e
	add	hl,hl		; x2
	add	hl,de		; x3
	ex	de,hl

	ld	hl,TEMPONUM
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl		; TEMPOREST
	ld	de,640
	ld	(hl),e
	inc	hl
	ld	(hl),d

	ld	a,$01
	ld	(TEMPOFLAG),a
	ret

;
; OPÑ|[gAregEreg̓eo͂
;
OUTOPN:
	push	af
.loop:	in	a,($a3)
	rlca
	jr	c,.loop
	pop	af
	out	($a0),a
	ld	a,e		; ԑ҂iKvHj
	ld	a,e		; ԑ҂iKvHj
	ld	a,e
	out	($a1),a
	ret

;
; OPÑ|[gAreg̓e͂
;
INOPN:
	push	af
.loop:	in	a,($a3)
	rlca
	jr	c,.loop
	pop	af
	out	($a0),a
	ld	a,e		; ԑ҂iKvHj
	ld	a,e		; ԑ҂iKvHj
	ld	a,e
	in	a,($a2)
	ret

;
; 10iASCII16iϊ
;
; HL <= 擪AhX
;
; RETURN:
; DE <= 16iit_ꍇAD=0x80j
; HL <= |C^i߂AhX
;
ANA_NUM:
	ld	de,$0000

.loop:
	ld	a,(hl)
	cp	'.'
	jr	nz,.no_dp
	ld	d,$80
	inc	hl
	ret

.no_dp:	sub	'0'
	ret	c
	cp	10
	ret	nc

	ex	de,hl

	add	hl,hl		; x2
	ld	b,h
	ld	c,l
	add	hl,hl		; x4
	add	hl,hl		; x8
	add	hl,bc		; x10
	ld	b,$00
	ld	c,a
	add	hl,bc
	ex	de,hl

	inc	hl
	jr	.loop

;
; 64Zɂ
;
; D <= 0x80At_
; E <= 
;
; RETURN:
; E <= 64Z̉
LENGTHCONV:
	ld	a,e
	or	a
	jr	nz,.no_num

	ld	e,(ix+LENGTH)
	ld	a,e
	cp	24
	jr	z,.l24

	ld	b,e
	srl	b
	jr	.dp_cal


.no_num:

	cp	24
	jr	z,.l24

	ld	e,$00
		;
		; 1/2/4/8/16/32/64 ȊO͑Ή
		;

	rrca
	rl	e
	rrca
	rl	e
	rrca
	rl	e
	rrca
	rl	e
	rrca
	rl	e
	rrca
	rl	e
	ld	b,e
	rrca
	rl	e

.dp_cal:
	bit	7,d
	ret	z

	ld	a,b
	add	a,e
	ld	e,a
	ret

.l24:
	ld	e,3
	ld	a,(ix+TRIFLAG)
	dec	a
	cp	$ff
	jr	z,.l24_lp
	ld	a,2
	dec	e
.l24_lp:
	ld	(ix+TRIFLAG),a
	ret

;
; MML|C^̏ݒ
;
INIT_MML:
	ld	hl,DATADD	; |C^̃|C^̏ݒ
	ld	de,DATPP
	ld	bc,$000c
	ldir

	ld	hl,DATPP	; |C^ݒ
	ld	de,DATP
	ld	b,6
.lp1:	push	bc
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	hl
	ld	a,(bc)
	ld	(de),a
	inc	bc
	inc	de
	ld	a,(bc)
	ld	(de),a
	inc	de
	pop	bc
	djnz	.lp1

	ret

;
; MMLǂݍ
;
; (ANACH) <= CHԍ(#0`#5j
;
; RETURN:
; Zflag=1:Cflag=1:f[^I
; Zflag=1:Cflag=0:ݒf[^I
; Zflag=0:Cflag=1:߂I
; Zflag=0:Cflag=0:ʏ
;
READ_MML:
	push	hl
	push	de
	push	bc

	ld	a,(ANACH)
	add	a,a
	ld	c,a
	ld	b,$00
	ld	hl,DATPP
	add	hl,bc
	ld	(.datpp1+1),hl
	ld	(.datpp2+1),hl
	ld	(.datpp3+1),hl

	ld	hl,DATP
	add	hl,bc
	ld	(.datp1+1),hl
	ld	(.datp2+1),hl
	ld	(.datp3+1),hl

	ld	bc,STRBUF

	ld	e,(hl)
	inc	hl
	ld	d,(hl)		; (de) f[^

	ex	de,hl		; (hl) f[^
.lp2:
	ld	e,(hl)
	inc	hl
	ld	d,(hl)		; de f[^

	inc	d
	inc	de
	ld	a,d
	or	e
	jr	nz,.dat_cnt	; f[^=0xFEFFł͂ȂAWv

		;
		; f[^߂̏I[
		;
.datpp1:ld	hl,$0000
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	de
	inc	de		; de |C^̃|C^
.datpp2:ld	hl,$0000
	ld	(hl),e
	inc	hl
	ld	(hl),d

	ex	de,hl		; hl |C^̃|C^

	ld	e,(hl)
	inc	hl
	ld	d,(hl)		; de |C^

	ld	a,d
	or	e
	scf
	jp	z,.end2		; |C^=0x0000̎AWviMMLIj

	inc	de
	ld	a,d
	or	e
	jr	nz,.end3

		; ݒIi|C^=0xFFFFj
		;
	inc	hl		; hl |C^̃|C^
	ex	de,hl
.datpp3:ld	hl,$0000
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ex	de,hl

	ld	e,(hl)
	inc	hl
	ld	d,(hl)		; de |C^

.datp3:	ld	hl,$0000
	ld	(hl),e
	inc	hl
	ld	(hl),d

	xor	a
	jr	.end2



		; ߏI
		;
.end3:
	dec	de

.datp1:	ld	hl,$0000
	ld	(hl),e
	inc	hl
	ld	(hl),d

	ld	a,$01
	or	a
	scf
	jr	.end2


.dat_cnt:
	ex	de,hl

.datp2:	ld	hl,$0000
	ld	(hl),e
	inc	hl
	ld	(hl),d

	ex	de,hl
	dec	hl
	ld	a,(hl)
	cp	' '
	inc	hl
	jr	z,.lp2

	cp	'A'
	jr	c,.nobig
	cp	'Z'+1
	jr	nc,.nobig
	add	a,'a'-'A'
.nobig:	ld	(bc),a
	inc	bc

	cp	'@'
	jr	nz,.no_atm

	ld	a,(hl)
	cp	'v'
	jr	z,.lp2
	cp	'V'
	jr	z,.lp2

.no_atm:
	cp	'm'
	ld	a,(hl)
	jr	nz,.no_m

	cp	'f'
	jr	z,.lp2
	cp	'F'
	jr	z,.lp2
	cp	'b'
	jp	z,.lp2
	cp	'B'
	jp	z,.lp2

.no_m:
	cp	' '
	jr	nz,.spc_1
	inc	hl
	ld	a,(hl)
.spc_1:
	or	a
	jr	z,.end
	cp	$ff
	jr	z,.end

	cp	'@'
	jr	z,.end
	cp	'>'
	jr	z,.end
	cp	'<'
	jr	z,.end

	cp	'A'
	jp	c,.lp2
	cp	'Z'+1
	jr	c,.end

	cp	'a'
	jp	c,.lp2
	cp	'z'+1
	jp	nc,.lp2

.end:	ld	a,$01
	or	a
.end2:	ld	a,$00
	ld	(bc),a
	pop	bc
	pop	de
	pop	hl
	ret


BGM_INTMAIN:
		;
		; ʒpL[
		; L[͏Ɋ荞݂ꍇAL[͏͂Ȃ
		; i͎蔲j
		;
	ld	hl,$000d
	add	hl,sp
	ld	a,(hl)
	sub	a,$24
	jp	z,.mainr
	dec	a
	jp	z,.mainr

	xor	a
	call	READBUF
	jp	z,.mainr

	ld	hl,FMOFFSET
	cp	"F"	; FMʂ
	jr	nz,.kin1
	ld	a,(hl)
	dec	a
	cp	$7f
	jr	nz,.kin02
	ld	a,$80
.kin02:	ld	(hl),a
	jr	.c_vol

.kin1:	cp	"f"	; FMʂグ
	jr	nz,.kin2
	ld	a,(hl)
	inc	a
	cp	$80
	jr	nz,.kin12
	ld	a,$7f
.kin12:	ld	(hl),a
	jr	.c_vol

.kin2:	dec	hl	; SSGOFFSET
	cp	"s"	; SSGʂ
	jr	nz,.kin3
	ld	a,(hl)
	dec	a
	cp	$ef
	jr	nz,.kin22
	ld	a,$f0
.kin22:	ld	(hl),a
	jr	.c_vol

.kin3:	cp	"S"	; SSGʂグ
	jr	nz,.kin4
	ld	a,(hl)
	inc	a
	cp	$10
	jr	nz,.kin32
	ld	a,$0f
.kin32:	ld	(hl),a
	jr	.c_vol

.kin4:	cp	"r"	; ɖ߂
	jr	nz,.kin5
	xor	a
	ld	(hl),a
	inc	hl
	ld	(hl),a
	jr	.c_vol

.kin5:
		;
		; ǂݏoL[f[^ǂłȂɂ
		;
	ld	e,a
	xor	a
	call	SETBACKBUF
	jp	.mainr

.c_vol:

	xor	a
	ld	ix,CH0DAT
	ld	(ANACH),a
	ld	a,(ix+CHVOL)
	call	ANA_MML.fm_volume
	ld	a,$01
	ld	ix,CH1DAT
	ld	(ANACH),a
	ld	a,(ix+CHVOL)
	call	ANA_MML.fm_volume
	ld	a,$02
	ld	ix,CH2DAT
	ld	(ANACH),a
	ld	a,(ix+CHVOL)
	call	ANA_MML.fm_volume


	ld	ix,CH3DAT
	ld	a,(ix+ENVENB)
	or	a
	ld	a,$03
	ld	e,(ix+CHVOL)
	call	z,ANA_MML.ssg_volume

	ld	ix,CH4DAT
	ld	a,(ix+ENVENB)
	or	a
	ld	a,$04
	ld	e,(ix+CHVOL)
	call	z,ANA_MML.ssg_volume

	ld	ix,CH5DAT
	ld	a,(ix+ENVENB)
	or	a
	ld	a,$05
	ld	e,(ix+CHVOL)
	call	z,ANA_MML.ssg_volume

.mainr:

		;
		; o
		;
	ld	hl,P_FLAG
	ld	a,(hl)
	or	a
	jp	z,.end


		;
		; e|̌vZɂA荞ݎɏ邩ǂ̔
		;

	ld	hl,(TEMPOREST)
	ld	de,(TEMPONUM)
	or	a
	sbc	hl,de
	ld	(TEMPOREST),hl
	jr	z,.play
	jp	nc,.end

.play:
	ld	de,640
	add	hl,de
	ld	(TEMPOREST),hl


		;
		; A641/9̐xŌĂяo
		;
	ld	hl,RCNT
	ld	a,(hl)
	inc	a
	cp	$09
	jr	c,.rcnt_lp
	xor	a
.rcnt_lp:
	ld	(hl),a

		; RCNT
		; 0           -> 1 -> .. -> 5 -> 6 -> 7 -> 8 -> 0
		;
		; MML(L[I)
		;                                          c炷
		; q=?L[It  1          5    6    7    8


	xor	a
	ld	(SSGOUTFLAG),a

.lp_ch2:
	xor	a
	ld	(ANACH),a
	ld	ix,CH0DAT

		;
		; CHƂ̏
		;
.lp_ch:
	ld	a,(ix+CHENB)
	or	a
	jp	z,.end_1ch

	ld	a,(RCNT)
	or	a
	jr	nz,.no_q0

.lp_ana:
	ld	a,(ix+ANAENB)
	or	a
	jr	z,.end_1ch

	call	READ_MML
	jr	c,.data_end
	call	ANA_MML
	jr	.lp_ana

.data_end:
	jr	z,.mml_end

	ld	a,(MBACKFLAG)
	or	a
	jr	nz,.lp_ana

.sent_end:
	xor	a
	ld	(ix+ANAENB),a
	inc	a
	ld	(ix+SENTENDFLAG),a
	jr	.end_1ch

.mml_end:
	ld	a,$01
	ld	(ix+MMLENDFLAG),a
	jr	.sent_end

.no_q0:
	ld	e,(ix+RATIO)
	cp	e
	jr	nz,.q8

	ld	a,(ix+OUTENB)
	or	a
	jr	z,.q8

	ld	a,(ix+DATCNT)
	dec	a
	jr	nz,.q8
	ld	a,(ix+TIEFLAG)
	or	a
	jr	nz,.q8

	xor	a
	ld	(ix+OUTENB),a

	ld	a,(ANACH)
	cp	$03
	jr	nc,.ssg_off

		;
		; FM~߂
		;
	ld	a,(ANACH)
	ld	e,a
	ld	a,$28		; L[It
	call	OUTOPN
	jr	.q8

.ssg_off:
	ld	a,$01
	ld	(SSGOUTFLAG),a

.q8:
	ld	a,(RCNT)
	cp	$08
	jr	nz,.end_1ch

	ld	a,(ix+DATCNT)
	dec	a
	ld	(ix+DATCNT),a
	jr	nz,.end_1ch

	ld	a,$01
	ld	(ix+ANAENB),a

	ld	a,(ix+MMLENDFLAG)
	xor	$01
	ld	(ix+CHENB),a

.end_1ch:
	ld	a,(ANACH)
	inc	a
	ld	(ANACH),a
	ld	de,CHDATNUM
	add	ix,de
	cp	$06
	jp	c,.lp_ch

		;
		; Ȃ̏IH
		;
	ld	a,$01
	ld	de,CHDATNUM
	ld	hl,CH0DAT+MMLENDFLAG
	ld	b,6
.mmlflag:
	and	(hl)
	add	hl,de
	djnz	.mmlflag
	or	a
	jr	z,.sentend2


		;
		; Ȃŏ
		;
;	ld	a,'E'			; debug
;	ld	($0000),a		; debug


	ld	b,6
	ld	ix,CH0DAT

.mmlinit_lp:
	ld	(ix+CHENB),$01
	ld	(ix+MMLENDFLAG),$00
	ld	(ix+SENTENDFLAG),$00
	ld	(ix+TRIFLAG),$00

	ld	de,CHDATNUM
	add	ix,de
	djnz	.mmlinit_lp


	call	INIT_MML


	xor	a
	ld	(ANACH),a
	ld	ix,CH0DAT
.lp_set:
	call	READ_MML
	jr	z,.no_data
	jr	c,.lp_set
	jr	.lp_set

.no_data:
	jr	nc,.set_end
	xor	a
	ld	(ix+CHENB),a		; ̃`l̓fBZ[u
	ld	a,$01
	ld	(ix+MMLENDFLAG),a

.set_end:
	ld	a,(ANACH)
	inc	a
	ld	(ANACH),a
	ld	de,CHDATNUM
	add	ix,de
	cp	$06
	jr	c,.lp_set

	jr	.sent_ana


.sentend2:
	ld	a,(MBACKFLAG)
	or	a
	jr	nz,.ssg_out

		;
		; ߂̏I킹邩ǂmF
		;
	ld	b,6
	ld	ix,CH0DAT
	ld	c,$01
.sentend_lp:
	ld	a,(ix+CHENB)
	xor	$01
	or	(ix+MMLENDFLAG)
	or	(ix+SENTENDFLAG)
	and	c
	ld	c,a

	ld	de,CHDATNUM
	add	ix,de
	djnz	.sentend_lp

	ld	a,c
	or	a
	jr	z,.ssg_out

.sent_ana:
	ld	b,6
	ld	ix,CH0DAT

.sentana_lp:
	ld	(ix+SENTENDFLAG),$00
	ld	(ix+ANAENB),$01
	ld	a,(ix+MMLENDFLAG)
	xor	$01
	ld	(ix+CHENB),a

	ld	de,CHDATNUM
	add	ix,de
	djnz	.sentana_lp

	jp	.lp_ch2

		;
		; SSG𔭉
		;
.ssg_out:
	ld	a,(SSGOUTFLAG)
	or	a
	jr	z,.end

	ld	a,(CH5DAT+OUTENB)
	rlca
	ld	e,a
	ld	a,(CH4DAT+OUTENB)
	or	e
	rlca
	ld	e,a
	ld	a,(CH3DAT+OUTENB)
	or	e
	xor	$07
	ld	e,a

	ld	a,(MIXDAT)
	or	e
	ld	e,a

	ld	a,$07
	call	OUTOPN		; CH3,4,5𔭉

.end:	ret


POKKY_INIT:
	xor	a
	ld	ix,CH0DAT
	ld	(ANACH),a
	ld	e,62
	call	ANA_MML.timble_set

	ld	a,$06
	ld	e,21
	call	OUTOPN
	ld	a,$b0
	ld	(MIXDAT),a

	ret



SSGOFFSET:	db	$00
FMOFFSET:	db	$00

MIXDAT:		db	$b8

DATDEF:		db	$01,$00,$01,$ff,$00,$04,$08,$10,$00,$00,$00,$00,$00,$00,$00

FMTONE:		dw	$0269	; C
		dw	$028e	; C+
		dw	$02b5	; D+
		dw	$02de	; D+
		dw	$030a	; E
		dw	$0338	; F
		dw	$0369	; F+
		dw	$039d	; G
		dw	$03d4	; G+
		dw	$040e	; A
		dw	$044c	; A+
		dw	$048d	; B
SSGTONE:	dw	$1ddc	; C	o0̉Kf[^
		dw	$1c2f	; C+
		dw	$1a9a	; D+
		dw	$191c	; D+
		dw	$17b3	; E
		dw	$165e	; F
		dw	$151d	; F+
		dw	$13ee	; G
		dw	$12cf	; G+
		dw	$11c1	; A
		dw	$10c2	; A+
		dw	$0fd1	; B

TEMPONUM:	dw	$0000
TEMPOREST:	dw	$0000
RCNT:		db	$00
MBACKFLAG:	db	$00
TEMPOFLAG:	db	$00

ANACH:		db	$00
SSGOUTFLAG:	db	$00
STRBUF:		db	8 dup ($00)

DATPP:		dw	$0000	; tӏ̃f[^ւ̃|C^(CH#0)
		dw	$0000	; (CH#1)
		dw	$0000	; (CH#2)
		dw	$0000	; (CH#3)
		dw	$0000	; (CH#4)
		dw	$0000	; (CH#5)

DATP:		dw	$0000	; tӏւ̃|C^(CH#0)
		dw	$0000	; (CH#1)
		dw	$0000	; (CH#2)
		dw	$0000	; (CH#3)
		dw	$0000	; (CH#4)
		dw	$0000	; (CH#5)

CHENB:		equ	0	; `lCl[u
OUTENB:		equ	1	; Cl[uixA$00j
ANAENB:		equ	2	; MML̓Cl[u
TIMBLE:		equ	3	; Fԍ
TIMALGO:	equ	4	; FASY
OCTAVE:		equ	5	; IN^[u
RATIO:		equ	6	; ̊iOFFɂȂ^C~Oj
LENGTH:		equ	7	; i64Zj
DATCNT:		equ	8	; ci64Zj
TRIFLAG:	equ	9	; RAtO
TIEFLAG:	equ	10	; ^CtOiqlĂOFFɂȂȂj
SENTENDFLAG:	equ	11	; ߏItO
MMLENDFLAG:	equ	12	; MMLItO
CHVOL:		equ	13	; ʒl
ENVENB:		equ	14	; Gx[vtO
CHDATNUM:	equ	15	; f[^

CH0DAT:		db	CHDATNUM dup ($00)
CH1DAT:		db	CHDATNUM dup ($00)
CH2DAT:		db	CHDATNUM dup ($00)
CH3DAT:		db	CHDATNUM dup ($00)
CH4DAT:		db	CHDATNUM dup ($00)
CH5DAT:		db	CHDATNUM dup ($00)


	org	$b1ff
	db	$00

end
