;
; \
;
; gp@FVIEW 

;
; L[́iINKEY$̐Łj
;
; gp@FA = KEY(0)
;
; L[͂ꂽf[^𐔒lŕԂB̓_~[B
;

;
; SD6031P31t@CI
;
; gp@FCHAIN D,FN$
;
; DFhCuԍi1`4j
; FN$Ft@Ci.P31͏j
;

;
; STOP,ESC,CTRL-C̃LZ
;

	relaxed on

HOOKVIEW	equ	$e7b1
HOOKKEY		equ	$e83d
HOOKCHAIN	equ	$e75b
HOOKSTOP	equ	$efd8
HOOKKEYIN	equ	$e602
ERROR_MO	equ	$2eb7
ANA_EXP		equ	$37d9
GET_WORD	equ	$3e1b
GET_BYTE	equ	$4bf7
COUNT_STR	equ	$4a56
COLOR_F		equ	$ec7d
COLOR_B		equ	$ec7e
SET_GVRAM	equ	$00ed
PSET		equ	$00ff
ATTCODE		equ	$ed81
RPORT60		equ	$e6a7
WPORT68		equ	$e6af
VALADD		equ	$6c4c
FAC2INT		equ	$01ef
FAC		equ	$ef63
INT2FAC		equ	$01ec
KEYIN		equ	$011a
PUT_INT		equ	$3de7
SENDCMD		equ	$019b
SENDDT		equ	$019e
GET_SUB		equ	$02a7
ESC_RET		equ	$0366
NOESC_RET	equ	$02eb

EXFDDF		equ	$dffe
EXRAMF		equ	$dfff
CMD_ADSUB	equ	$d306
BUFNUM1		equ	$d309
BUFNUM2		equ	$d30a

	org	$d800

	jp	SET_HOOK	; 0xD800
	jp	RBANK		; 0xD803
	jp	WBANK		; 0xD806
	jp	RBANKROM	; 0xD809
	jp	WBANKROM	; 0xD80C

	org	$d810

CUR_Y	db	$00		; 0xD810
CUR_X	db	$00		; 0xD811


SET_HOOK:
	ld	hl,VIEW_START
	ld	(HOOKVIEW),hl
	ld	hl,KEY_START
	ld	(HOOKKEY),hl
	ld	hl,CHAIN_START
	ld	(HOOKCHAIN),hl
	ld	hl,STOPCAN_START
	ld	a,$c3
	ld	(HOOKSTOP),a
	ld	(HOOKSTOP+1),hl
	di
	ld	hl,ESCCAN_START
	ld	(HOOKKEYIN),hl
	ei
	ret

;
; VIEW 
; VIEW @obt@ԍ,obt@ꏊ,擪̕,
;
VIEW_START:
	ld	a,(hl)
	cp	'@'
	jr	nz,.cmd2
	inc	hl

	call	ANA_EXP
	push	hl
	call	GET_BYTE	;  => A	iobt@ԍj
	ld	(BUFNUM1),a
	pop	hl

	rst	$08
	db	','

	call	ANA_EXP
	push	hl
	call	GET_BYTE	;  => A	iobt@ꏊj
	ld	(BUFNUM2),a
	pop	hl

	rst	$08
	db	','

	call	ANA_EXP
	push	hl
	call	GET_BYTE	;  => A	i擪̕j
	dec	a
	ld	(.bufnum+1),a
	pop	hl

	rst	$08
	db	','

	call	ANA_EXP
	push	hl
	call	GET_BYTE	;  => A	ij
	push	af

	ld	hl,(CUR_Y)
	call	CALCVRAM
	ld	(POS_X),hl
	ld	(POS_Y),de

	call	CMD_ADSUB
.bufnum:
	ld	de,$0000
	add	hl,de

	pop	af
	jr	.cmdall

.cmd2:
	call	ANA_EXP
	push	hl
	call	COUNT_STR
	push	hl

	ld	hl,(CUR_Y)
	call	CALCVRAM
	ld	(POS_X),hl
	ld	(POS_Y),de

	pop	hl
	ld	a,(hl)		; ̕
	or	a
	jr	z,.end
	inc	hl
	inc	hl
	ld	e,(hl)		; 擪AhX
	inc	hl
	ld	d,(hl)		; 擪AhX
	ex	de,hl

		; Areg  <= 
		; HLreg <= 擪AhX

.cmdall:
	ld	b,a

.loop:
	ld	d,(hl)
	inc	hl
	ld	e,(hl)

	push	bc
	push	hl

	call	CONV_KANJI

	pop	hl
	pop	bc

	dec	a
	jr	z,.jp1

	inc	hl
	dec	b

.jp1:
	push	bc
	push	hl

	call	CALCADD
	call	PUT_CHAR

	pop	hl
	pop	bc

	dec	b
	ld	a,b
	cp	$02
	jr	nc,.loop


.end:
	pop	hl
	ret



;
; LN^R[hSpR[hɕϊ
;
; D <= PoCgڂ̃f[^
; E <= QoCgڂ̃f[^
;
; RETURN:
; DE <= R[h
; A  <= ǂݍ񂾃oCg
;
CONV_KANJI:
	ld	a,d
	cp	$20
	jr	c,.error1
	jr	z,.spc
	cp	$80
	jr	c,.ascii
	cp	$a0
	jr	c,.kanji
	cp	$e0
	jr	c,.kana

.kanji:
	ld	hl,$9872
	or	a
	sbc	hl,de
	jr	c,.error2	; Q

	ld	a,e
	cp	$40
	jr	c,.error2
	cp	$7f
	jr	z,.error2
	cp	$fd
	jr	nc,.error2

	ld	a,$02
	ret

.spc:	sub	a,e
	ld	a,d
	jr	nz,.ascii

	ld	a,$02
	ld	de,$8140
	ret

.kana:	sub	$20
.ascii:	sub	$20
	ld	l,a
	ld	h,$00
	add	hl,hl
	ld	bc,ASCIITABLE
	add	hl,bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)

	ld	a,$01
	ret

.error1:
	ld	a,$01
	db	$11	; ld	de,$023e
.error2:
	ld	a,$02
	ld	de,$8140
	ret


ASCIITABLE:
	dw	$8140,$8149,$8168,$8194,$8190,$8193,$8195,$8166 ;@Ihf
	dw	$8169,$816a,$8196,$817b,$8143,$817c,$8144,$815e ;ij{C|D^
	dw	$824f,$8250,$8251,$8252,$8253,$8254,$8255,$8256 ;OPQRSTUV
	dw	$8257,$8258,$8146,$8147,$8183,$8181,$8184,$8148 ;WXFGH
	dw	$8197,$8260,$8261,$8262,$8263,$8264,$8265,$8266 ;`abcdef
	dw	$8267,$8268,$8269,$826a,$826b,$826c,$826d,$826e ;ghijklmn
	dw	$826f,$8270,$8271,$8272,$8273,$8274,$8275,$8276 ;opqrstuv
	dw	$8277,$8278,$8279,$816d,$818f,$816e,$814f,$8151 ;wxymnOQ
	dw	$8165,$8281,$8282,$8283,$8284,$8285,$8286,$8287 ;e
	dw	$8288,$8289,$828a,$828b,$828c,$828d,$828e,$828f ;
	dw	$8290,$8291,$8292,$8293,$8294,$8295,$8296,$8297 ;
	dw	$8298,$8299,$829a,$816f,$8162,$8170,$8160,$8140 ;obp`@
	dw	$8140,$8142,$8175,$8176,$8141,$8145,$82f0,$829f ;@BuvAE
	dw	$82a1,$82a3,$82a5,$82a7,$82e1,$82e3,$82e5,$82c1 ;
	dw	$815b,$82a0,$82a2,$82a4,$82a6,$82a8,$82a9,$82ab ;[
	dw	$82ad,$82af,$82b1,$82b3,$82b5,$82b7,$82b9,$82bb ;
	dw	$82bd,$82bf,$82c2,$82c4,$82c6,$82c8,$82c9,$82ca ;ĂƂȂɂ
	dw	$82cb,$82cc,$82cd,$82d0,$82d3,$82d6,$82d9,$82dc ;˂̂͂Ђӂւق
	dw	$82dd,$82de,$82df,$82e0,$82e2,$82e4,$82e6,$82e7 ;݂ނ߂
	dw	$82e8,$82e9,$82ea,$82eb,$82ed,$82f1,$814a,$814b ;JK

;
; R[h擪AhXϊ
;
; DE <= R[h
;
; RETURN:
; (CHARADD) <= 擪AhX
;
CALCADD:
	push	bc
	push	de
	push	hl

	ld	a,d
	sub	$80
	cp	$08
	jr	nc,.jp1
	ld	hl,$0000-$05e0
	ld	bc,$05e0
.jp2:	add	hl,bc
	dec	a
	jr	nz,.jp2

	ld	a,e
	sub	$40
	cp	$3f
	jr	c,.jp3
	dec	a
.jp3:	ld	e,a
	ld	d,$00
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	jr	.end

.jp1:	sub	$07
	ld	hl,$12fe-$0524
	ld	bc,$0524
.jp4:	add	hl,bc
	dec	a
	jr	nz,.jp4

	ld	a,e
	sub	$40
	cp	$3f
	jr	c,.jp5
	dec	a
.jp5:	ld	e,a
	ld	d,$00
	ex	de,hl
	ld	b,h
	ld	c,l
	add	hl,hl
	add	hl,hl
	add	hl,hl
	or	a
	sbc	hl,bc
	add	hl,de

.end:
	ld	(CHARADD),hl
	pop	hl
	pop	de
	pop	bc

	ret

;
; VRAMAhXZo
; H <= XWi80j
; L <= YWi25sj
;
; RETURN:
; HL <= XW
; DE <= YW
;
CALCVRAM:
	ld	a,l
	rlca			; x2
	rlca			; x4
	rlca			; x8
	ld	e,a
	ld	d,$00

	ld	l,h
	ld	h,$00
	add	hl,hl		; x2
	add	hl,hl		; x4

	ret

;
; P\
;
; (POS_X) <= XW
; (POS_Y) <= YW
; (CHARADD) <= 擪AhX
;
PUT_CHAR:
	call	GET_PATTERN

	ld	hl,PATTERN
	ld	b,$08
	ld	a,(POS_Y)
	ld	c,a
	xor	a
	out	($cf),a

.loop:	push	bc
	ld	a,c
	out	($ce),a

	ld	de,(POS_X)
	ld	bc,$0008
	ldir

	pop	bc
	inc	c
	djnz	.loop


	ld	hl,CUR_X
	inc	(hl)
	inc	(hl)

	ld	hl,(POS_X)
	ld	bc,$0008
	add	hl,bc
	ld	(POS_X),hl

	ret

;
; p^[擾
;
; (CHARADD) <= 擪AhX
;
; RETURN:
; (PATTERN) <= p^[f[^
;
GET_PATTERN:
	ld	de,(CHARADD)
	ld	a,(EXRAMF)
	or	a
	jr	nz,.exr1
	ld	a,d
	cp	$40
	jr	c,.h1
	add	a,$79
	cp	$d0
	jr	c,.h1
	add	a,$20
.h1:	ld	d,a
.exr1:

	di

	ld	a,$20
	call	RBANK

	ld	b,$09
	ld	hl,PATBUF

.lpbuf:	ld	a,(de)
	ld	(hl),a
	inc	hl
	inc	de

	ld	a,(EXRAMF)
	or	a
	jr	nz,.exr2
	ld	a,d
	cp	$40
	jr	nz,.h2
	ld	d,$b9
.h2:	cp	$d0
	jr	nz,.exr2
	ld	d,$f0
.exr2:
	djnz	.lpbuf

	call	RBANKROM
	ei

	ld	hl,(CHARADD)
	ld	de,$1590	; ̎n܂
	xor	a
	sbc	hl,de
	jr	c,.cont
	ld	(PATBUF+7),a
.cont:

	ld	hl,PATTERN
	ld	de,PATBUF

	ld	bc,$0801

.loop4:	push	hl
.loop3:	ld	a,(de)
	and	c

	ld	a,(COLOR_F)
	jr	nz,.front
	ld	a,(COLOR_B)
.front:	dec	a
	ld	(hl),a
	ld	a,l
	add	a,$08
	ld	l,a
	ld	a,h
	adc	a,$00
	ld	h,a

	rlc	c
	jr	nc,.loop3
	inc	de

	pop	hl
	inc	hl
	djnz	.loop4

	ret


PAT00:	db	$00
POS_X:	dw	$0000
POS_Y:	dw	$0000

CHARADD:dw	$0000

PATBUF:	db	8 dup ($00)
PATTERN:db	64 dup ($00)



; L[́iINKEY$̐Łj
;
; gp@FA = KEY(0)
;
; L[͂ꂽf[^𐔒lŕԂB̓_~[B
;
KEY_START:
	call	KEYIN
	ld	l,$00
	jr	z,.no_k
	ld	l,a
.no_k:	ld	h,$00
	call	PUT_INT		; HL <= Ԃl
	ret



;
; SD6031P31t@CI
;
; gp@FCHAIN D,FN$
;
; DFhCuԍi1`4j
; FN$Ft@Ci.P31͏j
;
CHAIN_START:
	call	ANA_EXP
	push	hl		; ̓|C^
	call	GET_BYTE	;  => A
	ld	(DRVNO),a

	pop	hl		; ̓|C^
	rst	08h
	db	","

	call	ANA_EXP
	push	hl		; ̓|C^
	call	COUNT_STR

	ld	a,(EXFDDF)
	or	a
	jr	z,.end

	ld	a,(hl)		; ̕
	or	a
	jr	z,.end
	inc	hl
	inc	hl
	ld	e,(hl)		; 擪AhX
	inc	hl
	ld	d,(hl)		; 擪AhX
	ex	de,hl

		; Areg  <= 
		; HLreg <= 擪AhX

	ld	c,a

		;
		; Set Image File
		;
	ld	a,$fe
	call	SENDCMD
	jr	c,.end

	ld	a,(DRVNO)
	dec	a
	call	SENDDT
	jr	c,.end

	inc	c

	ld	b,$08
.loop:	dec	c
	ld	a,(hl)
	jr	nz,.dtsnd
	ld	a," "
	ld	c,$01
.dtsnd:	call	SENDDT
	jr	c,.end
	inc	hl
	djnz	.loop

.end:	pop	hl
	ret


DRVNO:	db	$00


;
; STOPL[LZ
;
STOPCAN_START:
	pop	hl
	pop	hl
.end:	pop	hl
	pop	de
	pop	af
	pop	bc
	ei
	ret

;
; ESCL[LZ
; (L[荞݃[`)
;
ESCCAN_START:
	push	bc
	push	af
	call	GET_SUB
	ld	b,$00
	cp	$1b		; ESC
	jr	z,.esc
	cp	$03		; CTRL-C
	jp	nz,NOESC_RET

.esc:
	push	de
	push	hl
	push	hl

	jp	ESC_RET


;
; ǂݏooNݒ肷
;
RBANK:
	ld	bc,$045f
.loop:	inc	c
	out	(c),a
	inc	a
	inc	a
	djnz	.loop
	ret

;
; ݃oNݒ肷
;
WBANK:
	ld	bc,$0467
.loop:	inc	c
	out	(c),a
	inc	a
	inc	a
	djnz	.loop
	ret

;
; ǂݏooNɖ߂
;
RBANKROM:
	ld	bc,$045f
	ld	hl,RPORT60
.loop:	inc	c
	outi
	jr	nz,.loop
	ret

;
; ݃oNɖ߂
;
WBANKROM:
	ld	bc,$0467
	ld	hl,WPORT68
.loop:	inc	c
	outi
	jr	nz,.loop
	ret

	org	$dcff

	db	$00

end
