function fput2b(VALUE,   tmphigh,tmplow) {
	tmphigh = int(VALUE / 256);
	tmplow = VALUE - tmphigh * 256;
	printf("%02X%02X",tmplow,tmphigh);
	return 0;
}

BEGIN {
	lineno = 1;
	timnum = 1;
}

{
	if ($1 >= 23 && $1 <= 27) {
		sub(/.*DATA /,"");
		gsub(/ /,"");
		timcnt = split($0,timbuf,",");
		for (i = 1;i <= timcnt;i ++) {
			tim[timnum] = timbuf[i];
			timnum ++;
		}
		$0 = "";
	}


	if ($1 >= 39 && $1 <= 88) {
		sub(/SO/,"S0");
		sub(/.*DATA /,"");
		gsub(/"/,"");
		split($0,mml,",");

		mml1buf[lineno] = sprintf("%s\xFF\xFE",mml[1]);
		mml2buf[lineno] = sprintf("%s\xFF\xFE",mml[2]);
		mml3buf[lineno] = sprintf("%s\xFF\xFE",mml[3]);
		mml4buf[lineno] = sprintf("%s\xFF\xFE",mml[4]);
		mml5buf[lineno] = sprintf("%s\xFF\xFE",mml[5]);
		mml6buf[lineno] = sprintf("%s\xFF\xFE",mml[6]);

		lineno ++;
	}


}

END {

	lineno --;

# wb_ 0x8900

	add = 0x8900;

	addch1 = add + 2*6 + 25;
	addch2 = addch1 + 2*lineno + 4;
	addch3 = addch2 + 2*lineno + 4;
	addch4 = addch3 + 2*lineno + 4;
	addch5 = addch4 + 2*lineno + 4;
	addch6 = addch5 + 2*lineno + 4;

	add1mml[1] = addch6 + 2*lineno + 4;

	add2mml[1] = add1mml[1] + length(mml1buf[1]);
	add3mml[1] = add2mml[1] + length(mml2buf[1]);
	add4mml[1] = add3mml[1] + length(mml3buf[1]);
	add5mml[1] = add4mml[1] + length(mml4buf[1]);
	add6mml[1] = add5mml[1] + length(mml5buf[1]);

	for (i = 2;i <= lineno;i ++) {
		add1mml[i] = add6mml[i-1] + length(mml6buf[i-1]);
		add2mml[i] = add1mml[i] + length(mml1buf[i]);
		add3mml[i] = add2mml[i] + length(mml2buf[i]);
		add4mml[i] = add3mml[i] + length(mml3buf[i]);
		add5mml[i] = add4mml[i] + length(mml4buf[i]);
		add6mml[i] = add5mml[i] + length(mml5buf[i]);
	}

	fput2b(addch1);	# CH1̊Jnʒu
	fput2b(addch2);	# CH2̊Jnʒu
	fput2b(addch3);	# CH3̊Jnʒu
	fput2b(addch4);	# CH4̊Jnʒu
	fput2b(addch5);	# CH5̊Jnʒu
	fput2b(addch6);	# CH6̊Jnʒu

	printf("%02X",tim[1]);				# B0
	printf("%02X",tim[19]*16+tim[18]);	# 30
	printf("%02X",tim[39]*16+tim[38]);	# 34
	printf("%02X",tim[29]*16+tim[28]);	# 38
	printf("%02X",tim[49]*16+tim[48]);	# 3C
	printf("%02X",tim[16]);				# 40
	printf("%02X",tim[36]);				# 44
	printf("%02X",tim[26]);				# 48
	printf("%02X",tim[46]);				# 4C
	printf("%02X",tim[17]*64+tim[11]);	# 50
	printf("%02X",tim[37]*64+tim[31]);	# 54
	printf("%02X",tim[27]*64+tim[21]);	# 58
	printf("%02X",tim[47]*64+tim[41]);	# 5C
	printf("%02X",tim[12]);				# 60
	printf("%02X",tim[32]);				# 64
	printf("%02X",tim[22]);				# 68
	printf("%02X",tim[42]);				# 6C
	printf("%02X",tim[13]);				# 70
	printf("%02X",tim[33]);				# 74
	printf("%02X",tim[23]);				# 78
	printf("%02X",tim[43]);				# 7C
	printf("%02X",tim[15]*16+tim[14]);	# 80
	printf("%02X",tim[35]*16+tim[34]);	# 84
	printf("%02X",tim[25]*16+tim[24]);	# 88
	printf("%02X",tim[45]*16+tim[44]);	# 8C


	for (i = 1;i <= lineno;i ++) {
		fput2b(add1mml[i]);
		if (i == 1) {
			fput2b(0xffff);
		} else if (i == lineno) {
			fput2b(0x0000);
		}
	}

	for (i = 1;i <= lineno;i ++) {
		fput2b(add2mml[i]);
		if (i == 1) {
			fput2b(0xffff);
		} else if (i == lineno) {
			fput2b(0x0000);
		}
	}

	for (i = 1;i <= lineno;i ++) {
		fput2b(add3mml[i]);
		if (i == 1) {
			fput2b(0xffff);
		} else if (i == lineno) {
			fput2b(0x0000);
		}
	}

	for (i = 1;i <= lineno;i ++) {
		fput2b(add4mml[i]);
		if (i == 1) {
			fput2b(0xffff);
		} else if (i == lineno) {
			fput2b(0x0000);
		}
	}

	for (i = 1;i <= lineno;i ++) {
		fput2b(add5mml[i]);
		if (i == 1) {
			fput2b(0xffff);
		} else if (i == lineno) {
			fput2b(0x0000);
		}
	}

	for (i = 1;i <= lineno;i ++) {
		fput2b(add6mml[i]);
		if (i == 1) {
			fput2b(0xffff);
		} else if (i == lineno) {
			fput2b(0x0000);
		}
	}

	printf("@@@@@");

	for (i = 1;i <= lineno;i ++) {
		printf("%s",mml1buf[i]);
		printf("%s",mml2buf[i]);
		printf("%s",mml3buf[i]);
		printf("%s",mml4buf[i]);
		printf("%s",mml5buf[i]);
		printf("%s",mml6buf[i]);
	}

}
