/***************************/
/* ASCII to binary for awk */
/***************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp,*outfp;
	int		c;
	int		stcnt,up;
	int		convflag;


	if (argc != 3) {
		fprintf(stderr, "Usage: asc2bin infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	convflag = 1;
	stcnt = 0;
	while ((c = fgetc(infp)) != EOF) {
		if (convflag == 0) {
			fputc(c,outfp);
		} else {
			if (c == '@') {
				stcnt ++;
				if (stcnt == 5) {
					convflag = 0;
					stcnt = 0;
				}
			} else if ( (c >= '0' && c <= '9') || (c >= 'A' && c <= 'F') ) {
				if (c >= 'A' && c <= 'F') {
					c = c - 'A' + 10;
				} else {
					c = c - '0';
				}
				stcnt ++;
				if (stcnt == 2) {
					fputc(up+c,outfp);
					stcnt = 0;
				} else {
					up = c * 0x10;
				}
			} else {
				printf("Illigal data!!\n");
				exit(1);
			}
		}
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}
