
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN	20


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	char	outfile[S_LEN];
	int		num,c,outnum;
	int		fileno;

	if (argc != 3) {
		fprintf(stderr, "Usage: convfont infile outfile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	fileno = 1;

	sprintf(outfile,"%s%d",argv[2],fileno);
	if ((outfp = fopen(outfile, "wb")) == NULL) {
		perror(outfile);
		exit(1);
	}

	num = 0;
	outnum = 0;
	while ((c = fgetc(infp)) != EOF) {
		if (num >= 0x7798) {
			break;
		}


		if ( (num % 8) == 7 && num > 0x1610) {
			;
		} else if (num < 0x80) {
			;
		} else if (0x1610 <= num && num < 0x1af0) {
			;
		} else {

			if (outnum == 0x1FC0 || outnum == 0x3F80 || outnum == 0x5700) {
				fclose(outfp);
				fileno ++;
				sprintf(outfile,"%s%d",argv[2],fileno);
				if ((outfp = fopen(outfile, "wb")) == NULL) {
					perror(outfile);
					exit(1);
				}
			}

			fputc(c,outfp);
			outnum ++;
		}
		num ++;
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}
