
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*
*/

#define	HEADER		0x0C00

void	fput3b(long int,FILE *);

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		c,i,j;
	int		msgbuf[60];
	int		spcflag;
	int		secno;
	long int		picheader[HEADER];

	if (argc != 3) {
		fprintf(stderr, "Usage: convmseg infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

// wb_̏l
	for (i = 0;i < HEADER;i ++) {
		picheader[i] = 0x00;
		fputc(0x00,outfp);
	}

	for (secno = 0;;secno ++) {

		if (secno >= HEADER) {
			goto LPEND;
		}

		picheader[secno] = ftell(outfp) + 0x100;

		for (j = 0;j < 3;j ++) {

			spcflag = -1;
			for (i = 0;i < 60;i ++) {
				if ( (c = fgetc(infp)) == EOF) {
					goto LPEND;
				}
				msgbuf[i] = c;
				if (spcflag == -1) {
					if (c == 0x20) {
						spcflag = i;
					}
				} else {
					if (c != 0x20) {
						spcflag = 0xff;
					}
				}
			}

			for (i = 0;i < 60;i ++) {
				if (spcflag == i) {
					fputc(0xff,outfp);
					break;
				}
				fputc(msgbuf[i],outfp);
			}


			for (i = 0;i < 1;i ++) {
				if ( (c = fgetc(infp)) == EOF) {
					goto LPEND;
				}
				fputc(c,outfp);
			}

			spcflag = 1;
			for (i = 0;i < 19;i ++) {
				if ( (c = fgetc(infp)) == EOF) {
					goto LPEND;
				}
				msgbuf[i] = c;
				if (c != 0x20) {
					spcflag = 0;
				}
			}

			if (spcflag == 0) {
				for (i = 0;i < 19;i ++) {
					fputc(msgbuf[i],outfp);
				}
			} else {
				fputc(0xff,outfp);
			}

		}

		for (i = 0;i < 16;i ++) {
			if ( (c = fgetc(infp)) == EOF) {
				goto LPEND;
			}
		}

	}

LPEND:

	fseek(outfp,0,SEEK_SET);

	for (i = 0;i < secno;i ++) {
		fput3b(picheader[i],outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}


void	fput3b(long int d,FILE *fp)
{
	int	d0,d1,d2;

	d0 = (d & 0x000000ff);
	d1 = (d & 0x0000ff00) >> 8;
	d2 = (d & 0x00ff0000) >> 16;

	fputc(d0,fp);
	fputc(d1,fp);
	fputc(d2,fp);

	return;
}

